<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
<head>
  <title>&Auml;nderung der Collation von MySQL-4-Tabellen</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <meta http-equiv="Content-Language" content="de" />
  <meta name="author" content="Enigma" />
  <style type="text/css">
    <!--
    body, p, span {
      font-family: Arial, Helvetica, sans-serif;
      font-size: 1em;
    }
    
    h1 {
      font-family: Arial, Helvetica, sans-serif;
      font-size: 2em;
    }
    pre {
      font-family: "Courier New", Courier, monospace;
      font-size: 0.8em;
    }
    .sql {
      font-family: "Courier New", Courier, monospace;
      font-size: 0.8em;
    }
    -->
  </style>
</head>

<body>
  <h1>&Auml;nderung der Collation von MySQL-4-Tabellen</h1>

<?php
  // bitte Datenbank-Daten hier eingeben:
  $db_server = 'mysql4.domain.tld oder localhost';
  $db_name   = 'whle dein db aus';
  $db_user   = 'db12345';
  $db_pass   = 'passwort';

  // bitte alte und neue Collation in korrekter Schreibweise hier eingeben
  // (muss zum eingestellten Charset passen!):
  $old_collation = 'latin1_swedish_ci';
  $new_collation = 'latin1_german1_ci';

  // neue Collation in Tabellenfeldern definieren, fr die bisher keine
  // Collation definiert ist (also die Standard-Collation des Servers gilt)?
  // true fr ja, false fr nein
  $insert_collation = true;




  /*******************************************************************************
  * ab hier bitte nur dann nderungen vornehmen, wenn Du weit, was Du tust!  ;-)
  *******************************************************************************/


  // Datentypen definieren, die eine Collation besitzen knnen
  // evtl. nicht ntig...
  $coll_types = array('CHAR',
                      'VARCHAR',
                      'TEXT',
                      'TINYTEXT',
                      'MEDIUMTEXT',
                      'LONGTEXT',
                      'ENUM',
                      'SET');

  // Verbindung zur Datenbank herstellen
  $connection_id = mysql_connect($db_server, $db_user, $db_pass);
  if (mysql_error() != '') {
    echo '<span style="color: #FF0000; font-weight: bold;">'.mysql_error()."</span><br />\n";
    exit;
  }
  mysql_select_db($db_name, $connection_id);
  if (mysql_error() != '') {
    echo '<span style="color: #FF0000; font-weight: bold;">'.mysql_error()."</span><br />\n";
    exit;
  }

  // MySQL-Befehl zum Einschalten der "Backticks" fr Tabellennamen und Feldnamen
  // im CREATE-TABLE-Statement
  $sql = "SET SQL_QUOTE_SHOW_CREATE = 1";
  $result = mysql_query($sql, $connection_id);
  if (mysql_error() != '') {
    echo '<span style="color: #FF0000; font-weight: bold;">'.mysql_error()."</span><br />\n";
  }

  // Default-Collate fr die Datenbank ndern
  echo '<p><strong>Datenbank: '.$db_name."</strong><br />\n";
  $sql = "ALTER DATABASE `".$db_name."` DEFAULT COLLATE ".$new_collation;
  echo '<span class="sql">'.$sql."</span></p>\n";
  $result = mysql_query($sql, $connection_id);
  if (mysql_error() != '') {
    echo '<span style="color: #FF0000; font-weight: bold;">'.mysql_error()."</span><br />\n";
  }

  // Tabellennamen auslesen
  $tables = array();
  $sql = "SHOW TABLES FROM `".$db_name."`";
  $result = mysql_query($sql, $connection_id);
  if (mysql_error() != '') {
    echo '<span style="color: #FF0000; font-weight: bold;">'.mysql_error()."</span><br />\n";
  }
  while ($row = mysql_fetch_row($result)) {
    $tables[] = trim($row[0]);
  }
  mysql_free_result($result);

  // Tabellen nacheinander abarbeiten
  foreach ($tables as $table_name) {
    echo "<p>&nbsp;<br />\n<strong>Tabelle: ".$table_name."</strong><br />\n";

    // Default-Collate fr die Tabelle ndern
    $sql = "ALTER TABLE `".$table_name."` DEFAULT COLLATE ".$new_collation;
    echo '<span class="sql">'.$sql."</span><br />\n";
    $result = mysql_query($sql, $connection_id);
    if (mysql_error() != '') {
      echo '<span style="color: #FF0000; font-weight: bold;">'.mysql_error()."</span><br />\n";
    }

    // gesamten CREATE-TABLE-Befehl durch MySQL ausgeben lassen
    $sql = "SHOW CREATE TABLE `".$table_name."`";
    $result = mysql_query($sql, $connection_id);
    if (mysql_error() != '') {
      echo '<span style="color: #FF0000; font-weight: bold;">'.mysql_error()."</span><br />\n";
    }
    $row = mysql_fetch_assoc($result);
    $table_definition = $row['Create Table'];
    mysql_free_result($result);

    // Details ber die einzelnen Tabellenfelder auslesen
    $sql = "SHOW FULL COLUMNS FROM ".$table_name;
    $result = mysql_query($sql, $connection_id);
    if (mysql_error() != '') {
      echo '<span style="color: #FF0000; font-weight: bold;">'.mysql_error()."</span><br />\n";
    }
    $field_details = array();
    $key = 0;
    while ($row = mysql_fetch_assoc($result)) {
      // mit Index 1 beginnen, um bereinstimmung mit $counter in der for-Schleife weiter unten
      // zu erreichen
      $key++;

      // $field_details[$key]['name']       = $row['Field'];
      // $field_details[$key]['type']       = $row['Type'];
      $field_details[$key]['basic_type'] = preg_replace('#^([a-z]+)(\(.*\).*)?#i', '$1', $row['Type']);
      // $field_details[$key]['collation']  = $row['Collation'];
    }

    // Modifizierung der einzelnen Tabellenfelder
    $sql_modify = "ALTER TABLE `".$table_name."`";
    // ermittelten CREATE-TABLE-Befehl an den Zeilenumbrchen zerlegen
    // und die Zeilen in ein Array bernehmen
    $definition_lines = explode("\n", str_replace("\r", '', $table_definition));

    // erste und letzte Zeile nicht bercksichtigen, da dort keine relevanten Informationen zu finden sind
    for ($counter = 1; $counter <= count($definition_lines) - 2; $counter++) {
      $definition_lines[$counter] = trim($definition_lines[$counter]);

      // KEY / INDEX nicht ndern
      if (!preg_match('#^((primary|unique)\s*)?(key|index)#i', $definition_lines[$counter])) {
        $new_def_line = preg_replace('#(collate[\s=]+)'.trim($old_collation).'#i', '$1'.trim($new_collation), $definition_lines[$counter]);

        // Wenn fr ein Feld, das eine Collation besitzen kann, nicht explizit eine Collation
        // gespeichert wurde, wird offenbar die Default-Collation *des MySQL-Servers* und nicht
        // die der Datenbank oder der Tabelle verwendet (dies gilt nicht fr Felder, die nach
        // nderung der Default-Collation der Datenbank oder der Tabelle angelegt werden).
        // Damit in solchen Feldern die neue Collation eingerichtet wird, muss sie der Definition
        // hinzugefgt werden.
        if ($insert_collation and in_array(strtoupper($field_details[$counter]['basic_type']), $coll_types)) {
          if (!preg_match('#\scollate[\s=]#i', $new_def_line)) {
            $new_def_line = preg_replace('#\s*,\s*$#', ' collate '.trim($new_collation).',', $new_def_line);
          }
        }

        // MODIFY-Zeile dem SQL-Befehl hinzufgen
        $sql_modify .= "\n  MODIFY ".$new_def_line;
      }
    }

    // Komma an Ende ggf. eliminieren
    $sql_modify = preg_replace('#\s*,\s*$#', '', $sql_modify);
    echo '<pre>'.$sql_modify."</pre><br />\n";
    $result = mysql_query($sql_modify, $connection_id);
    if (mysql_error() != '') {
      echo '<span style="color: #FF0000; font-weight: bold;">'.mysql_error()."</span><br />\n";
    }

    echo "</p>\n";
  }

  mysql_close($connection_id);

  echo "<p><br />\n<strong>Skript beendet.</strong></p>\n";
?>

</body>
</html>
